% practice05_2.m
%
% $Id: practice05_2.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ɤ߹ߤɽ
pictureRgb = imread('./data/firenzeRgb.jpg');
pictureGray = rgb2graycq(pictureRgb);
figure(1);
imshowcq(pictureGray);
title('Original');

% Υääɤ߹ߤɽ
pictureNoisy = imread('./data/firenzeNoisy.jpg');
figure(2);
imshowcq(pictureNoisy);
title('Before filtering');

% ե륿ȷ̤ɽ
[nRows nCols] = size(pictureNoisy);
% ͤ
pictureNoisy = [zeros(nRows,1) pictureNoisy zeros(nRows,1)];
pictureNoisy = [zeros(1,nCols+2) ; pictureNoisy ; zeros(1,nCols+2)];
% ե륿
for iCol = 1:nCols
    for iRow = 1:nRows
        % 3x3 ΰڤФ(ʿľΣǤΤա
        subDomain = pictureNoisy(iRow:iRow+2, iCol:iCol+2);
        % , , Ǿ͡ˤν
        pictureMedian(iRow,iCol) = median(subDomain(:));
        pictureMax(iRow,iCol) = max(subDomain(:));
        pictureMin(iRow,iCol) = min(subDomain(:));
    end
end
figure(3);
imshowcq(pictureMedian);
title('After filtering (median)');

figure(4);
imshowcq(pictureMax);
title('After filtering (max)');

figure(5);
imshowcq(pictureMin);
title('After filtering (min)');

% end 
