% practice05_5.m
%
% $Id: practice05_5.m,v 1.3 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ޥ
prewittMask = [ 1  1  1;
                0  0  0;
               -1 -1 -1 ];
             
% ɤ߹ߤɽ
pictureRgb = imread('./data/firenzeRgb.jpg');
pictureGray = rgb2graycq(pictureRgb);
figure(1);
imshowcq(pictureGray);
title('Original');

% ե륿ȷ̤ɽ
pictureVerFiltered = ...
    filter2(prewittMask, pictureGray);
pictureHorFiltered = ...
    filter2(prewittMask.', pictureGray);
pictureFiltered = uint8(...
    abs(pictureVerFiltered) ...
    + abs(pictureHorFiltered) );
figure(2);
imshowcq(pictureFiltered);
title('After filtering (prewitt)');

% Ͳȷ̤ɽ
level = 128;
pictureBinary = zeros(size(pictureFiltered),'uint8');
pictureBinary(find(pictureFiltered>=level)) = uint8(255); 
pictureBinary = reshape(pictureBinary,size(pictureFiltered));
figure(3);
imshowcq(pictureBinary);
title('After filtering (binary)');

% end 
