% practice06_11.m
%
% $Id: practice06_11_ip.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ԗ
uFactor = 5;
% Ԉ
dFactor = 6;

% ̓t@C
fileNameIn = './data/calcio.avi';
fileInfoIn = aviinfo(fileNameIn);
frameRateIn = fileInfoIn.FramesPerSecond;
nFrames = fileInfoIn.NumFrames;
fprintf('̓t[[g: %f [fps]\n',frameRateIn);

% o̓t@C
fileNameOut = './tmp/calcioFps25.avi';
frameRateOut = frameRateIn * uFactor / dFactor;
clear mex;
aviObj = avifile(fileNameOut,'FPS',frameRateOut,'COMPRESSION','None');

for iFrame = 1:dFactor:nFrames
    % t[̓Ǐo(Input phase 0)
    pictureCur = frame2im(aviread(fileNameIn,iFrame));

    % t[̏o(Output phase 0)
    pictureOut = pictureCur; % d 1
    aviObj = addframe(aviObj,im2frame(pictureOut));

    % t[̓Ǐo(Input phase 1)
    picturePre = frame2im(aviread(fileNameIn,iFrame+1));    

    % t[̓Ǐo(Input phase 2)
    pictureCur = frame2im(aviread(fileNameIn,iFrame+2)); 

    % t[̏o(Output phase 1)
    pictureOut = imlincomb(7/8, picturePre, 1/8, pictureCur);
    aviObj = addframe(aviObj,im2frame(pictureOut));

    % t[̓Ǐo(Input phase 3)
    picturePre = pictureCur;
    pictureCur = frame2im(aviread(fileNameIn,iFrame+3));    

    % t[̏o(Output phase 2)
    pictureOut = imlincomb(5/8, picturePre, 3/8, pictureCur);
    aviObj = addframe(aviObj,im2frame(pictureOut));        
    
    % t[̓Ǐo(Input phase 4)
    picturePre = pictureCur;
    pictureCur = frame2im(aviread(fileNameIn,iFrame+4));    

    % t[̏o(Output phase 3)
    pictureOut = imlincomb(3/8, picturePre, 5/8, pictureCur);
    aviObj = addframe(aviObj,im2frame(pictureOut));        
    
    % t[̓Ǐo(Input phase 5)
    picturePre = pictureCur;
    pictureCur = frame2im(aviread(fileNameIn,iFrame+5));    

    % t[̏o(Output phase 4)
    pictureOut = imlincomb(1/8, picturePre, 7/8, pictureCur);
    aviObj = addframe(aviObj,im2frame(pictureOut));        

end
aviObj = close(aviObj);

fileInfoOut = aviinfo(fileNameOut);
fprintf('o̓t[[g: %f [fps]\n',fileInfoOut.FramesPerSecond);

% end 
