function y = dctiii(x,N);
% DCTIII   : 	 III  DCT        (ľ)
%
%	Y = DCTIII(X [,N])
%
%	X  : ϥ٥ȥ롤Ϲ 
%	N  : Ѵ
%	
%	Y  : X  DCT-III 
%
%	X ΤȤ٥ȥФѴ
%	N Ϳ줿硤礦褦ˡ
%	X Фղá뤤ڼΤƤԤʤ
%
%	See also: IDCTIII
%
%	Ref.:	K. R. Rao and P. Yip, "Discrete Cosine Transform",
%		Academic Press, 1990.
%
%		Written by S. Muramatsu (5 Oct.,`96)
%
%
% Copyright (C) 1996-2006 Shogo MURAMATSU, All rights reserved
%
error(nargchk(1,2,nargin));	% οΥå

% 

[x,flag] = rowvecck(x);		%  x ԥ٥ȥΤȤž֡
if nargin == 1	
	N = size(x,1);		% x ιԿѴ N Ȥ롥
else
	x = adjcsize(x,N);	% x Υ N ˹碌롥 
end;

% DCT-III 

Scale = sqrt(2/N);		% 
SQRT_H = 7.071067811865475e-01; % 2 ʿεտ

for m=0:N-1
	for n=0:N-1
		C(m+1,n+1) = Scale*cos(n*(m+.5)*pi/N); 
		if(n == 0) 
			C(m+1,1) = C(m+1,1)*SQRT_H;
	 	end;
	end;
end;

% DCT-III

y = C*x;

% 

if flag				%  x ԥ٥ȥΤȤ
	y = y.';		%  y ⡤ԥ٥ȥȤ롥
end;
