function fullPicture = im97itrnscq_ip(subLL,subHL,subLH,subHH);
%
% $Id: im97itrnscq_ip.m,v 1.3 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

a = -1.586134342059924;
b = -0.052980118572961;
g =  0.882911075530934;
d =  0.443506852043971;
K =  1.230174104914001;

% z̏
fullSize = size(subLL) + size(subHH);
fullPicture = zeros(fullSize);

% Wבւ
fullPicture(1:2:end,1:2:end,:) = subLL;
fullPicture(1:2:end,2:2:end,:) = subHL;
fullPicture(2:2:end,1:2:end,:) = subLH;
fullPicture(2:2:end,2:2:end,:) = subHH;

% ϊiCv[XZj
fullPicture(:,1:2:end,:) = fullPicture(:,1:2:end,:)*K;
fullPicture(:,2:2:end,:) = fullPicture(:,2:2:end,:)/K;
fullPicture = updateStep_ip(fullPicture.',-d);
fullPicture = predictionStep_ip(fullPicture,-g);
fullPicture = updateStep_ip(fullPicture,-b);
fullPicture = predictionStep_ip(fullPicture,-a).';

% ϊiCv[XZj
fullPicture(1:2:end,:,:) = fullPicture(1:2:end,:,:)*K;
fullPicture(2:2:end,:,:) = fullPicture(2:2:end,:,:)/K;
fullPicture = updateStep_ip(fullPicture,-d);
fullPicture = predictionStep_ip(fullPicture,-g);
fullPicture = updateStep_ip(fullPicture,-b);
fullPicture = predictionStep_ip(fullPicture,-a);

% end of im97itrnscq_ip
