% practice09_12.m
%
% $Id: practice09_12.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ְ2x2)
downMtx = [ 1 1 ; -1 1 ];

absDetD = abs(det(downMtx));

% ץȥװ켡ե륿߷
nOrder = 20; % ץȥץե륿μ
passBandEdge = 1/absDetD * 0.8;
stopBandEdge = 1/absDetD * 1.2;
freqWeight = 0.5;
prtFilter = eigLpFir(nOrder,passBandEdge,stopBandEdge,freqWeight);

% ְե륿߷1
phase = [0 0]; % 濴Ĥ褦ְΰĴ
filter4Dec1 = downsampleFilterDesign2(prtFilter, downMtx,phase);
% ɽ
figure(1);
freqz2cq(filter4Dec1);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('filter 1');

% ְե륿߷2
unimodMtx = [ 1 0 ; 1 -1 ];
phase = [0 0]; % 濴Ĥ褦ְΰĴ
filter4Dec2 = downsampleFilterDesign2(prtFilter, downMtx*unimodMtx, phase);
% ɽ
figure(2);
freqz2cq(filter4Dec2);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('filter 2');

%%% ǥ᡼¸ %%%

% ζʬ
covMtx  = [1 2 ; 2 8];
% Υ
sizeX = 63;

% 󼡸ؿˤ
arrayX = gaussian2cq(sizeX,covMtx);

% μȿ
figure(3);
freqz2cq(arrayX);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('Before decimation');
axis([-1 1 -1 1 0 1.2]);
    
% 󼡸ǥ᡼ʥե륿1
arrayFiltd1 = filter2(filter4Dec1,arrayX);
arrayY1 = downsample2(arrayFiltd1,downMtx);

% μȿ
figure(4);subplot(2,2,1);
freqz2cq(arrayFiltd1);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('After filtering with filter 1');
axis([-1 1 -1 1 0 1.2]);

figure(4);subplot(2,2,2);
freqz2cq(arrayY1);
xlabel('\omega_1/\pi');
ylabel('\omega_0/\pi');
title('After decimation with filter 1');
axis([-1 1 -1 1 0 1.2]);

% 󼡸ǥ᡼ʥե륿2
arrayFiltd2 = filter2(filter4Dec2,arrayX);
arrayY2 = downsample2(arrayFiltd2,downMtx);

% μȿ
figure(4);subplot(2,2,3);
freqz2cq(arrayFiltd2);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('After filtering with filter 2');
axis([-1 1 -1 1 0 1.2]);

figure(4);subplot(2,2,4);
freqz2cq(arrayY2);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('After decimation with filter 2');
axis([-1 1 -1 1 0 1.2]);

% end
