% practice14_10.m
%
% $Id: practice09_13_ip.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ԍsi2x2)
upMtx = [ 1 1 ; -1 1 ];
absDetU = abs(det(upMtx));

% vg^CvꎟtB^݌v
nOrder = 20; % vg^CvtB^̎
passBandEdge = 1/absDetU * 0.8;
stopBandEdge = 1/absDetU * 1.2;
freqWeight = 0.5;
prtFilter = eigLpNqFir(...
    nOrder,passBandEdge,stopBandEdge,freqWeight,absDetU);

% ԈtB^݌v1
phase = [0 0]; % Sc悤Ԉ̈ʑ𒲐
filter4Inp1 = absDetU * ...
   downsampleFilterDesign2(prtFilter, upMtx, phase);
% ̕\
figure(1);
freqz2(filter4Inp1);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('filter 1');

% ԈtB^݌v2
unimodMtx = [ 1 0 ; 1 -1 ];
phase = [0 0]; % Sc悤Ԉ̈ʑ𒲐
filter4Inp2 = absDetU * ... 
    downsampleFilterDesign2(prtFilter, upMtx*unimodMtx, phase);
% ̕\
figure(2);
freqz2(filter4Inp2);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('filter 2');

%%% C^|[V %%%

% M̋Us
covMtx  = [1 2 ; 2 8];
% M̃TCY
sizeX = 31;

% 񎟌KEX֐ƊԈɂz̐
arrayX = downsample2(gaussian2cq(sizeX,covMtx),upMtx);

% M̎gU
figure(3);subplot(2,2,1);
freqz2(arrayX);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('Before upsampling');
axis([-1 1 -1 1 0 1.2]);

% 񎟌AbvTvO
arrayUpSpd = upsample2(arrayX,upMtx);

% AbvTv̎gU
figure(3);subplot(2,2,2);
freqz2(arrayUpSpd);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('After upsampling');
axis([-1 1 -1 1 0 1.2]);

% 񎟌C^|[V(tB^1j
arrayY1 = filter2(filter4Inp1,arrayUpSpd);

% ̎gU
figure(3);subplot(2,2,3);
freqz2(arrayY1);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('After interpolation with filter 1');
axis([-1 1 -1 1 0 1.2]);

% 񎟌C^|[VitB^2j
arrayY2 = filter2(filter4Inp2,arrayUpSpd);

% ̎gU
figure(3);subplot(2,2,4);
freqz2(arrayY2);

xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('After interpolation with filter 2');
axis([-1 1 -1 1 0 1.2]);

% end
