% practice04_6.m
%
% $Id: practice04_6.m,v 1.4 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% եɹ
pictureRgb = imread('./data/firenzeRgb.jpg');

% ΥؤѴ
pictureGray = rgb2graycq(pictureRgb);

% Ĵ
nGrayLevels = 256; % ̵8bit

% βɽ
subplot(2,2,1);
imshowcq(pictureGray);
title('Before histgram equalization');

% Υҥȥβ
hx = histc(pictureGray(:),0:nGrayLevels-1);

% Υҥȥɽ
subplot(2,2,2);
stem(0:nGrayLevels-1,hx,'Marker','none');
axis([0 nGrayLevels 0 10000]);
title('Before histgram equalization');

% ҥȥη׻
nPixels = prod(size(pictureGray));
px = hx/nPixels;

% Ѵɽκ
lut = double([]);
lut(1) = px(1);
for iGrayLevel = 1:nGrayLevels-1
    lut(iGrayLevel+1) = lut(iGrayLevel)+px(iGrayLevel+1);
end
lutUint8 = uint8((nGrayLevels-1)*lut);

% ҥȥ
[nRows nCols] = size(pictureGray);
pictureHistEqd = uint8([]);
for iCol = 1:nCols
    for iRow = 1:nRows
        pictureHistEqd(iRow,iCol) = ...
            uint8(lutUint8(pictureGray(iRow,iCol)+1));
    end
end

% Υҥȥβ
hy = histc(pictureHistEqd(:),0:nGrayLevels-1);

% βɽ
subplot(2,2,3);
imshowcq(pictureHistEqd);
title('After histgram equalization');

% Υҥȥɽ
subplot(2,2,4);
stem(0:nGrayLevels-1,hy,'Marker','none');
axis([0 nGrayLevels 0 10000]);
title('After histgram equalization');

% end
