% practice05_7.m
%
% $Id: practice05_7.m,v 1.3 2007/05/16 07:23:59 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ϥե
fileNameIn = './data/calcio.avi';
fileInfo = aviinfo(fileNameIn);
frameRate = fileInfo.FramesPerSecond;
nFrames = fileInfo.NumFrames;

% ϥե
fileNameOut = './tmp/calcioFiltered.avi';
clear mex;
aviObj = avifile(fileNameOut,'FPS',frameRate,'COMPRESSION','None');

% ե졼ֺʬͽ
framePre = aviread(fileNameIn,1);
picturePre = rgb2graycq(framePre.cdata);
frameFiltered.colormap = gray(256); 

% ե졼ֺʬͽ
for iFrame = 1:nFrames
    % ե졼ɽФ
    frameCur = aviread(fileNameIn,iFrame);
    pictureCur = rgb2graycq(frameCur.cdata);
    % ե륿
    pictureFiltered = uint8(...
        0.5*(double(pictureCur)+double(picturePre)));
    %pictureFiltered = uint8(...
    %    abs(double(pictureCur)-double(picturePre)));
    % ե졼ν
    frameFiltered.cdata = pictureFiltered;
    aviObj = addframe(aviObj,frameFiltered);
    % ե졼ι
    picturePre = pictureCur;
end
aviObj = close(aviObj);

% end 
