% practice05_8.m
%
% $Id: practice05_8.m,v 1.3 2007/05/14 21:39:03 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% }XN̐ݒ
sizeMask = 3;
aveMask = ones([sizeMask sizeMask]);
aveMask = aveMask/sum(aveMask(:));

% 摜̓ǂݍ݂ƕ\
pictureRgb = imread('./data/barbaraFaceRgb.tif');
nRows = size(pictureRgb,1);
nCols = size(pictureRgb,2);
figure(1);
imshowcq(pictureRgb);
title('Original');

% tB^ilgjƌʂ̕\
clear pictureFilteredZp;
pictureFilteredZp(:,:,1) = ...
            uint8(filter2(aveMask,double(pictureRgb(:,:,1))));
pictureFilteredZp(:,:,2) = ...
            uint8(filter2(aveMask,double(pictureRgb(:,:,2))));
pictureFilteredZp(:,:,3) = ...
            uint8(filter2(aveMask,double(pictureRgb(:,:,3))));        
figure(2);
imshowcq(pictureFilteredZp);
title('After filtering (zero padding)');

% tB^igjƌʂ̕\
halfSize = (sizeMask-1)/2;
clear pictureFilteredVpe pictureFilteredPe;
% Ɏg
pictureRgbVpe = [ pictureRgb(end-halfSize:end,:,:) ;
                  pictureRgb(:,:,:) ;
                  pictureRgb(1:halfSize,:,:) ];
% Ɏg              
pictureRgbPe = [ pictureRgbVpe(:,end-halfSize:end,:) ...
                 pictureRgbVpe(:,:,:) ...
                 pictureRgbVpe(:,1:halfSize,:) ];
% tB^
clear pictureFilteredPe;
pictureFilteredPe(:,:,1) = ...
            uint8(filter2(aveMask,double(pictureRgbPe(:,:,1))));
pictureFilteredPe(:,:,2) = ...
            uint8(filter2(aveMask,double(pictureRgbPe(:,:,2))));
pictureFilteredPe(:,:,3) = ...
            uint8(filter2(aveMask,double(pictureRgbPe(:,:,3))));
% NbsO
clear pictureFilteredPec;
pictureFilteredPec = pictureFilteredPe(...
    halfSize+1:halfSize+nRows,...
    halfSize+1:halfSize+nCols,:);
% ʕ\
figure(3);
imshowcq(pictureFilteredPec);
title('After filtering (periodic extension)');

% tB^iΏ̊gjƌʂ̕\
halfSize = (sizeMask-1)/2;
clear pictureFilteredVse pictureFilteredSe;
% ɑΏ̊g
pictureRgbVse = [ pictureRgb(halfSize:-1:1,:,:) ;
                  pictureRgb(:,:,:) ;
                  pictureRgb(end:-1:end-halfSize,:,:) ];
% ɑΏ̊g              
pictureRgbSe = [ pictureRgbVse(:,halfSize:-1:1,:) ...
                 pictureRgbVse(:,:,:) ...
                 pictureRgbVse(:,end:-1:end-halfSize,:) ];
% tB^
clear pictureFilteredSe;
pictureFilteredSe(:,:,1) = ...
            uint8(filter2(aveMask,double(pictureRgbSe(:,:,1))));
pictureFilteredSe(:,:,2) = ...
            uint8(filter2(aveMask,double(pictureRgbSe(:,:,2))));
pictureFilteredSe(:,:,3) = ...
            uint8(filter2(aveMask,double(pictureRgbSe(:,:,3))));
% NbsO
clear pictureFilteredSec;
pictureFilteredSec = pictureFilteredSe(...
    halfSize+1:halfSize+nRows,...
    halfSize+1:halfSize+nCols,:);
% ʕ\
figure(4);
imshowcq(pictureFilteredSec);
title('After filtering (symmetric extension)');

% end 
