% practice06_11.m
%
% $Id: practice06_11.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ԗ
uFactor = 5;
% Ԉ
dFactor = 6;

% ̓t@C
fileNameIn = './data/calcio.avi';
fileInfoIn = aviinfo(fileNameIn);
frameRateIn = fileInfoIn.FramesPerSecond;
nFrames = fileInfoIn.NumFrames;
fprintf('̓t[[g: %f [fps]\n',frameRateIn);

% o̓t@C
fileNameOut = './tmp/calcioFps25.avi';
frameRateOut = frameRateIn * uFactor / dFactor;
clear mex;
aviObj = avifile(fileNameOut,'FPS',frameRateOut,'COMPRESSION','None');

frameOut.colormap = [];
for iFrame = 1:dFactor:nFrames
    % t[̓Ǐo(Input phase 0)
    frameCur = aviread(fileNameIn,iFrame);
    pictureCur = frameCur.cdata;

    % t[̏o(Output phase 0)
    pictureOut = pictureCur; % d 1
    frameOut.cdata = pictureOut;
    aviObj = addframe(aviObj,frameOut);

    % t[̓Ǐo(Input phase 1)
    framePre = aviread(fileNameIn,iFrame+1);    
    picturePre = framePre.cdata;

    % t[̓Ǐo(Input phase 2)
    frameCur = aviread(fileNameIn,iFrame+2); 
    pictureCur = frameCur.cdata;
    
    % t[̏o(Output phase 1)
    pictureOut = uint8( (...
        7.0 * double(picturePre) + ...
        1.0 * double(pictureCur) ) / 8 );
    frameOut.cdata = pictureOut;
    aviObj = addframe(aviObj,frameOut);        
    
    % t[̓Ǐo(Input phase 3)
    picturePre = pictureCur;
    frameCur = aviread(fileNameIn,iFrame+3);    
    pictureCur = frameCur.cdata;

    % t[̏o(Output phase 2)
    pictureOut = uint8( (...
        5.0 * double(picturePre) + ...
        3.0 * double(pictureCur) ) / 8 );
    frameOut.cdata = pictureOut;
    aviObj = addframe(aviObj,frameOut);        
    
    % t[̓Ǐo(Input phase 4)
    picturePre = pictureCur;
    frameCur = aviread(fileNameIn,iFrame+4);    
    pictureCur = frameCur.cdata;

    % t[̏o(Output phase 3)
    pictureOut = uint8( (...
        3.0 * double(picturePre) + ...
        5.0 * double(pictureCur) ) / 8 );
    frameOut.cdata = pictureOut;
    aviObj = addframe(aviObj,frameOut);            
    
    % t[̓Ǐo(Input phase 5)
    picturePre = pictureCur;
    frameCur = aviread(fileNameIn,iFrame+5);    
    pictureCur = frameCur.cdata;

    % t[̏o(Output phase 4)
    pictureOut = uint8( (...
        1.0 * double(picturePre) + ...
        7.0 * double(pictureCur) ) / 8 );
    frameOut.cdata = pictureOut;
    aviObj = addframe(aviObj,frameOut);                

end
aviObj = close(aviObj);

fileInfoOut = aviinfo(fileNameOut);
fprintf('o̓t[[g: %f [fps]\n',fileInfoOut.FramesPerSecond);

% end 
