% practice06_14.m
%
% $Id: practice06_14.m,v 1.3 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

%Ψ
uFactor = 5;
%ְΨ
dFactor = 6;
% ͭե
sFactor = max(uFactor,dFactor);

% ̲ü
pass = 1/sFactor * (1 - 1);
% ˻߰ü
stop = 1/sFactor * (1 + 1);
% Ťߥѥ᡼
alpha = 0.5;
% ե륿
nOrder = 8;

% ե륿߷
h = uFactor * eigLpNqFir(...
   nOrder,pass,stop,alpha,uFactor*dFactor);

% ѥ륹ɽ
figure(1);
impz(h);

% ȿɽ
figure(2);
[H,W] = freqz(h);
plot(W/pi,20*log10(abs(H)));
title(sprintf('Sampling Rate Conversion Filter (factor = %d/%d)',...
       uFactor,dFactor),...
      'FontSize',12);
xlabel('\omega [rad]/\pi','FontSize',12);
ylabel('|G(e^{j\omega})| [dB]','FontSize',12);
gain = 20*log10(uFactor);
axis([ 0 1 -80+gain 20+gain]);
grid on;
hold on;
line([0 1/sFactor 1/sFactor],[gain gain -100],...
    'LineStyle',':','LineWidth',2,'Color','red');
hold off;

% end
