% practice06_5.m
%
% $Id: practice06_5.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

%@Ԉ̐ݒi2ȏ̐j
dFactor = 2;

% ͐̐ݒ
startIndex = 1;
nInputSamples = 128; 
load gong;
inputSeq = y(startIndex:startIndex+nInputSamples-1);
load chirp;
inputSeq = inputSeq + y(startIndex:startIndex+nInputSamples-1);

% o͐̌vZ
outputSeq = downsample(inputSeq,dFactor);
nOutputSamples = length(outputSeq);

% ͐̕\
subplot(2,1,1);
[H,W] = freqz(inputSeq);
plot(W/pi,20*log10(abs(H)));
title('Input sequence','FontSize',12);
xlabel('\omega [rad]/\pi','FontSize',12);
ylabel('|X(e^{j\omega})| [dB]','FontSize',12);
axis([ 0 1 -70 30 ]);
grid on;

% o͐̕\
subplot(2,1,2);
[H,W] = freqz(outputSeq);
plot(W/pi,20*log10(abs(H)));
title(sprintf('Output sequence (dFactor = %d)',dFactor),'FontSize',12);
xlabel('\omega [rad]/\pi','FontSize',12);
ylabel('|Y(e^{j\omega})| [dB]','FontSize',12);
axis([ 0 1 -70 30 ]);
grid on;

% end
