function y = dcti(x,N);
% DCTI     : 	^Cv I  DCT	         (K)
%
%	Y = DCTI(X [,N])
%
%	X  : ̓xNgC͍s 
%	N  : ϊ_
%	
%	Y  : X  DCT-I W
%
%	X ŝƂCexNgɑ΂ĕϊ
%	N ^ꂽꍇCTCY悤ɁC
%	X ɑ΂ltC邢͐؎̂ĂsȂD
%
%	See also: IDCTI
%
%	Ref.:	K. R. Rao and P. Yip, "Discrete Cosine Transform",
%		Academic Press, 1990.
%
%		Written by S. Muramatsu (5 Oct.,`96)
%
% $Id: dcti.m,v 1.1 2006/04/19 17:34:37 sho Exp $
%
% Copyright (C) 1996-2006 Shogo MURAMATSU, All rights reserved
%
error(nargchk(1,2,nargin));	% ̐̃`FbN

% O

[x,flag] = rowvecck(x);		%  x sxNĝƂ]uD
if nargin == 1	
	N = size(x,1);		% x ̍sϊ_ N ƂD
else
	x = adjcsize(x,N);	% x ̃TCY_ N ɍ킹D 
end;

% DCT-I s̐

Scale = sqrt(2/(N-1));		% XP[
SQRT_H = 7.071067811865475e-01; % 2 ̋̕t

for m=0:N-1
	for n=0:N-1
		C(m+1,n+1) = Scale*cos(n*m*pi/(N-1)); 
		if(m == 0 | m == (N-1))
			C(m+1,n+1) = C(m+1,n+1)*SQRT_H;
		end;
		if(n == 0 | n == (N-1))
			C(m+1,n+1) = C(m+1,n+1)*SQRT_H;
		end;
	end;
end;

% DCT-I

y = C*x;

% ㏈

if flag				%  x CsxNĝƂC
	y = y.';		% o y CsxNgƂD
end;
