function y = dctiv(x,N);
% DCTIV    : 	 IV  DCT         (ľ)
%
%	Y = DCTIV(X [,N])
%
%	X  : ϥ٥ȥ롤Ϲ 
%	N  : Ѵ
%	
%	Y  : X  DCT-IV 
%
%	X ΤȤ٥ȥФѴ
%	N Ϳ줿硤礦褦ˡ
%	X Фղá뤤ڼΤƤԤʤ
%
%	See also: IDCTIV
%
%	Ref.:	K. R. Rao and P. Yip, "Discrete Cosine Transform",
%		Academic Press, 1990.
%
% $Id: dctiv.m,v 1.1 2006/04/19 17:34:37 sho Exp $
%
% Copyright (C) 1996-2006 Shogo MURAMATSU, All rights reserved
%
error(nargchk(1,2,nargin));	% οΥå

% 

[x,flag] = rowvecck(x);		%  x ԥ٥ȥΤȤž֡
if nargin == 1	
	N = size(x,1);		% x ιԿѴ N Ȥ롥
else
	x = adjcsize(x,N);	% x Υ N ˹碌롥 
end;

% DCT-IV 

Scale = sqrt(2/N);		% 

for m=0:N-1
	for n=0:N-1
		C(m+1,n+1) = Scale*cos((n+.5)*(m+.5)*pi/N); 
	end;
end;

% DCT-IV

y = C*x;

% 

if flag				%  x ԥ٥ȥΤȤ
	y = y.';		%  y ⡤ԥ٥ȥȤ롥
end;
