% practice07_2.m
%
% $Id: practice07_2_ip.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ɹ
pictureRgb = imread('data/barbaraFaceRgb.tif');
pictureGray = rgb2gray(pictureRgb);

% ɽ
figure(1);
imshow(pictureGray);
title('Original picture');

% 󼡸٥ȥ뽸
nPixels = prod(size(pictureGray));
setOfX = reshape(pictureGray.', 2, nPixels/2);

% Ѵλۿ
figure(2);
scatter(setOfX(1,:),setOfX(2,:),'.');
axis square;
xlabel('x_0'); ylabel('x_1');
title('Scatter plot (before transform)');

% Ѵ
setOfY = 1 / sqrt(2) * [ 1 1 ; -1 1 ] * double(setOfX);

% Ѵλۿ
figure(3);
scatter(setOfY(1,:),setOfY(2,:),'.');
axis square;
xlabel('y_0'); ylabel('y_1');
title('Scatter plot (after transform)');

% end
