% practice08_5.m
%
% $Id: practice08_5.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ®٥٥ȥʿľʿ
velocity = [2 1];

% 0ܥե졼ɹ
pictureOrg = double(imread('./data/gaussian2d.tif'))/255.0;

% ư
nFrames = 32;
picture = pictureOrg;
figure(1);
w = hanning(nFrames);
for iFrame = 1:nFrames
    array3d(:,:,iFrame) = w(iFrame)*picture;
    picture = circshift(picture, velocity);
    imshowcq(picture);
    drawnow;
end

% 3-D FFTη׻
sizeFft = [128 128 128];
freqChar3d = abs(fftshift(fftn(array3d, sizeFft)));
clear array3d;

% 3-D ڥȥɽ
figure(2);
freqChar3d = freqChar3d/max(freqChar3d(:));
freqChar3d = freqChar3d.^0.1;
[wt,wh,wv] = meshgrid( ...
    -1:2/sizeFft(3):1-2/sizeFft(3),...
    -1:2/sizeFft(1):1-2/sizeFft(1),...
    -1:2/sizeFft(2):1-2/sizeFft(2));
freqChar3d = permute(freqChar3d,[2 3 1]);
slice(wt,wh,wv,freqChar3d, 0 ,0, 0, 'nearest');
shading flat;
axis vis3d;
colormap(jet);
xlabel('\omega_T (\times\pi rad)');
ylabel('\omega_H (\times\pi rad)');
zlabel('\omega_V (\times\pi rad)');
clear freqChar3d wt wh wv

% end of practice08_5.m