% practice14_10.m
%
% $Id: practice09_13_ip.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ֹ2x2)
upMtx = [ 1 1 ; -1 1 ];
absDetU = abs(det(upMtx));

% ץȥװ켡ե륿߷
nOrder = 20; % ץȥץե륿μ
passBandEdge = 1/absDetU * 0.8;
stopBandEdge = 1/absDetU * 1.2;
freqWeight = 0.5;
prtFilter = eigLpNqFir(...
    nOrder,passBandEdge,stopBandEdge,freqWeight,absDetU);

% ְե륿߷1
phase = [0 0]; % 濴Ĥ褦ְΰĴ
filter4Inp1 = absDetU * ...
   downsampleFilterDesign2(prtFilter, upMtx, phase);
% ɽ
figure(1);
freqz2(filter4Inp1);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('filter 1');

% ְե륿߷2
unimodMtx = [ 1 0 ; 1 -1 ];
phase = [0 0]; % 濴Ĥ褦ְΰĴ
filter4Inp2 = absDetU * ... 
    downsampleFilterDesign2(prtFilter, upMtx*unimodMtx, phase);
% ɽ
figure(2);
freqz2(filter4Inp2);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('filter 2');

%%% 󥿥ݥ졼¸ %%%

% ζʬ
covMtx  = [1 2 ; 2 8];
% Υ
sizeX = 31;

% 󼡸ؿȴְˤ
arrayX = downsample2(gaussian2cq(sizeX,covMtx),upMtx);

% μȿ
figure(3);subplot(2,2,1);
freqz2(arrayX);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('Before upsampling');
axis([-1 1 -1 1 0 1.2]);

% 󼡸åץץ
arrayUpSpd = upsample2(arrayX,upMtx);

% åץץμȿ
figure(3);subplot(2,2,2);
freqz2(arrayUpSpd);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('After upsampling');
axis([-1 1 -1 1 0 1.2]);

% 󼡸󥿥ݥ졼(ե륿1
arrayY1 = filter2(filter4Inp1,arrayUpSpd);

% μȿ
figure(3);subplot(2,2,3);
freqz2(arrayY1);
xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('After interpolation with filter 1');
axis([-1 1 -1 1 0 1.2]);

% 󼡸󥿥ݥ졼ʥե륿2
arrayY2 = filter2(filter4Inp2,arrayUpSpd);

% μȿ
figure(3);subplot(2,2,4);
freqz2(arrayY2);

xlabel('\omega_1 (\times\pi rad)');
ylabel('\omega_0 (\times\pi rad)');
title('After interpolation with filter 2');
axis([-1 1 -1 1 0 1.2]);

% end
