% practice10_3.m
%
% $Id: practice10_3.m,v 1.10 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ®٥٥ȥʿľʿ
velocity = [2 2];

% mobile.avi Фξ true 
isMobileAvi = false;

if isMobileAvi
   aviInfo = aviinfo('tmp/mobile.avi'); % mobile.avi 4.9
   nFramesIn = aviInfo.NumFrames;
   frameRateIn = aviInfo.FramesPerSecond;
else
    % 󥿥졼ǥ
    frameSeq = mkInterlacedMov(velocity);
    nFramesIn = length(frameSeq);
    frameRateIn = 30;
end

% avifile ֥Ȥ
outputFileName = 'tmp/vtip.avi';
frameSize = size(frame2im(frameSeq(1)));
frameRateOut = 2 * frameRateIn;
nFrameOut = 2 * nFramesIn;
clear mex;
aviObj = avifile(outputFileName,...
    'FPS',frameRateOut,'COMPRESSION','None');

% ֿľIPѴ
deintPicture0 = 128*ones(frameSize,'uint8');
deintPicture1 = 128*ones(frameSize,'uint8');
previousField = 128*ones(frameSize./[2 1],'uint8');
for iFrame = 1:nFramesIn
    if isMobileAvi
        pictureI = rgb2graycq(frame2im(aviread('tmp/mobile.avi',iFrame)));
    else
        pictureI = frame2im(frameSeq(iFrame));
    end
    % Process for picture0
    deintPicture0(1:2:end,:) = ...
            1/4 * pictureI(2:2:end,:)...
            + 1/2 * previousField...
            + 1/4 * [pictureI(2,:) ; ...
                    pictureI(2:2:end-2,:)];
    deintPicture0(2:2:end,:) = pictureI(2:2:end,:);                
    previousField = pictureI(2:2:end,:);
    % Process for picture1
    deintPicture1(1:2:end,:) = pictureI(1:2:end,:);
    deintPicture1(2:2:end,:) = ...
            1/4 * pictureI(1:2:end,:)...
            + 1/2 * previousField...
            + 1/4 * [pictureI(3:2:end,:) ; ...
                    pictureI(end-1,:)];
    previousField = pictureI(1:2:end,:);
    %
    aviObj = addframe(aviObj, ...
        im2frame(deintPicture0,gray(256)));
    aviObj = addframe(aviObj, ...
        im2frame(deintPicture1,gray(256)));    
end
aviObj = close(aviObj);

%
