% practice10_4.m
%
% $Id: practice10_4.m,v 1.7 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2005-2007 Shogo MURAMATSU, All rights reserved
%

% ®٥٥ȥʿľʿ
velocity = [2 2];

% mobile.avi Фξ true 
isMobileAvi = false;

if isMobileAvi
   aviInfo = aviinfo('tmp/mobile.avi'); % mobile.avi 4.9
   nFramesIn = aviInfo.NumFrames;
   frameRateIn = aviInfo.FramesPerSecond;
else
    % 󥿥졼ǥ
    frameSeq = mkInterlacedMov(velocity);
    nFramesIn = length(frameSeq);
    frameRateIn = 30;
end

% avifile ֥Ȥ
outputFileName = 'tmp/adpip.avi';
frameSize = size(frame2im(frameSeq(1)));
frameRateOut = 2 * frameRateIn;
nFrameOut = 2 * nFramesIn;
clear mex;
aviObj = avifile(outputFileName,...
    'FPS',frameRateOut,'COMPRESSION','None');

% ưзŬIPѴ
deintPicture0 = 128*ones(frameSize,'uint8');
deintPicture1 = 128*ones(frameSize,'uint8');
previousField = 128*ones(frameSize./[2 1],'uint8');  
for iFrame = 1:nFramesIn
    if isMobileAvi
        pictureI = rgb2graycq(frame2im(aviread('tmp/mobile.avi',iFrame)));
    else
        pictureI = frame2im(frameSeq(iFrame));
    end
    % Process for picture0
    deintPicture0(2:2:end,:) = pictureI(2:2:end,:);
    % Vertical averaging    
    deintPicture0(1:2:end,:) = ...
                1/2 * pictureI(2:2:end,:) ...
                + 1/2 * [pictureI(2,:) ; ...
                     pictureI(2:2:end-2,:)];    
    % Comb detection
    alphaMap0 = abs( (...
        double(previousField) - double(deintPicture0(1:2:end,:)))/255);
    alphaMap0 = alphaMap0.^.25;
    % Adaptive interpolation
    deintPicture0(1:2:end,:) = uint8(...
        (1-alphaMap0) .* double(previousField) ...
        + alphaMap0 .* double(deintPicture0(1:2:end,:)));
    previousField = pictureI(2:2:end,:);    
    
    % Process for picture1
    deintPicture1(1:2:end,:) = pictureI(1:2:end,:);
    % Vertical averaging
    deintPicture1(2:2:end,:) = ...
                1/2 * pictureI(1:2:end,:) ...
                + 1/2 * [pictureI(3:2:end,:) ; ...
                    pictureI(end-1,:)];    
    % Comb detection
    alphaMap1 = abs( (...
        double(previousField) - double(deintPicture1(2:2:end,:)))/255);
    alphaMap1 = alphaMap1.^.25;  
    % Adaptive interpolation
    deintPicture1(2:2:end,:) = uint8(...
        (1-alphaMap1) .* double(previousField) ...
        + alphaMap1 .* double(deintPicture1(2:2:end,:)));
    previousField = pictureI(1:2:end,:);
    aviObj = addframe(aviObj, ...
        im2frame(deintPicture0,gray(256)));
    aviObj = addframe(aviObj, ...
        im2frame(deintPicture1,gray(256)));        
end
aviObj = close(aviObj);

%
    