function void = freqz2cq(arrayX)
%
% Input
%
%   arrayX: input array 
%
% Copyright (C) 2005-2006 Shogo MURAMATSU, All rights reserved
%
nPoints = pow2(ceil(log2(max([size(arrayX) 64]))));
freqX = fftshift(abs(fft2(double(arrayX),nPoints,nPoints)));
[f1,f0] = freqspace(nPoints);
[x,y]=meshgrid(f1,f0);
mesh(x,y,freqX);
xlabel('F_x');
ylabel('F_y');
zlabel('Magnitude');
%
